function ControlApp() {};
ControlApp.prototype = {
	initilialize: function(ifaces) {
		this.ifaces = ifaces;
		this.contactTimeOut = undefined;
		this.releaseTimeOut = undefined;
		var config = {
			controller: "browser",
			lifetime: "url"
		};
		this.ifaces.contact.setInputConfiguration(config)
		.then(function(e) {
			// Faire quelque chose
			console.log("success");
		})
		.catch(function(e) {
			// Gérer l'erreur
			console.log("faillure");
		});
		
		this.ifaces.contact.addListener(async (event) => {
			const info = event.detail;
			let currentFolder, muteState;
			if (info.type === 'input-change') {
				currentFolder = await this.ifaces.player.getFolderNumber();
				muteState = await this.ifaces.player.getMute();
				let inputActive = [];
				/**
				 * check all input-states and store them inside an array
				 */
				for (var i = 0 ; i < info.values.length ; i++) {
					if (info.values[i] === true) {
						inputActive.push(i)
					}
				}
				
				/**
				 * if at least one input return true we unmute player and playFolder2 if we are not inside
				 */
				if (inputActive.length > 0) {
					clearTimeout(this.releaseTimeOut);
					clearTimeout(this.contactTimeOut);
					this.ifaces.player.unmute();
					if (currentFolder !== 2) {
						this.contactTimeOut = setTimeout(() => {
							this.onContact();
						}, 4000);
					} else {
						this.ifaces.player.unmute();
					}
				} else {
					clearTimeout(this.contactTimeOut);
					if (currentFolder === 2) {
						await this.onRelease(muteState);
					}
				}
			}
		});

		this.ifaces.player.addListener((event) => {
			const info = event.detail;
			if (info.type === 'folder-enter') {
				this.currentFolder = info.folder.number;
				this.ifaces.player.unmute();
			}
		});
	},
	// methods
	onContact: function() {
		this.ifaces.player.playFolder(2);
	},
	
	onRelease: async function () {
		this.muteState = await this.ifaces.player.getMute();
		if (!this.muteState) {
			this.releaseTimeOut = setTimeout(async () => {
				if (this.currentFolder !== 1) this.ifaces.player.mute();
			}, 15000);
		}
	},
};

// initialize app + controler
window.addEventListener('load', function() {
IDAL.getControlInterfaces()
	.then(function(ifaces) {
		var app = new ControlApp();
		app.initilialize(ifaces);
	})		
});